import * as mc from '@minecraft/server';
import * as system from '@minecraft/server';
import * as ui from '@minecraft/server-ui';
//import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";
function getScore(objective, player) { try { return mc.world.scoreboard.getObjective(objective).getScore(player.scoreboard); } catch (error) { return 0; } }

mc.world.events.beforeItemUse.subscribe(data => {
  let { item, source } = data
  const plr = data.source
  if (item.typeId == "wesl3y:menu") {
    menu(plr);
  }
});

function menu(player) {
  const form = new ui.ActionFormData();
  const
    hero_villain = player.hasTag("hero") ? " Hero: §a" : player.hasTag("villain") ? " Villain: §e" : ": ",
    name = player.hasTag("all_might") ? "All Might" : player.hasTag("bakugou") ? "Bakugou" : player.hasTag("deku") ? "Deku" : player.hasTag("endeavor") ? "Endeavor" : player.hasTag("rule") ? "Rule" : player.hasTag("shoto") ? "Shoto" : player.hasTag("tsukuyomi") ? "Tsukuyomi" : player.hasTag("uravity") ? "Uravity" : player.hasTag("dabi") ? "Dabi" : player.hasTag("shigaraki") ? "Shigaraki" : player.nameTag
  form.title("Menu");
  form.body(`Name${hero_villain}${name}\n§rLevel: §a${getScore("level", player)}\n§rBody Strength: §a${getScore("body_strength", player)}\n§rStrength: §a${getScore("strength", player)}\n§rJump: §a${getScore("jump", player)}\n§rSpeed: §a${getScore("speed", player)}`);
  form.button("Inf");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      inf(player);
    }
  }
);}

function inf(player) {
  const form = new ui.ActionFormData();
  form.title("Inf");
  form.body("[Heroi]\n- §eDerrote vilões para subir de level.\n§r- §eSeu nome de heroi é escolhido aleatório, ele não muda em nada, é apenas para deixar mais legal.\n§r- §eVilões comuns são fáceis de derrotar,mas cuidado com o Dabi (Ele é forte).\n§r- §eClick agachado em um policial para abrir o menu de loja.\n\n§r[Vilão]\n- §cDerrote heróis para subir de level.\n§r- §cSeu nome de vilão e escolhido aleatório, ele não muda em nada, é apenas para deixar mais legal.\n§r- §cSeu maior problema com será o Deku Dark, ele é super forte.\n§r- §cClick agachado em um bandido para abrir o menu de loja.");
  form.button("Eng");
  form.button("Back");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      inf2(player);
    }
    if (r.selection === 1) {
      menu(player);
    }
  }
);}

function inf2(player) {
  const form = new ui.ActionFormData();
  form.title("Inf");
  form.body("[Hero]\n- §eDefeat villains to level up.\n§r- §eYour hero name is chosen at random, it doesn't change at all, it's just to make it more cool.\n§r-§e Common villains are easy to defeat, but watch out for Dabi (He's strong).\n§r- §eCrouch click on a policeman to open the shop menu.\n\n§r[Villain]\n- §cDefeat heroes to level up.\n§r- §cHis villain name is chosen at random, he doesn't change anything, it's just to make it cooler.\n§r- §cYour biggest problem with Deku Dark will be, he's super strong.\n§r- §cCrouch click on a bandit to open the shop menu.");
  form.button("Pt");
  form.button("Back");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      inf(player);
    }
    if (r.selection === 1) {
      menu(player);
    }
  }
);}


system.system.runInterval(() => {
  for (const player of mc.world.getPlayers()) {
    if (!player.hasTag("custom") && !(player.hasTag("hero") || player.hasTag("villain"))) custom(player);
  }
}, 5);

function custom(player) {
  player.addTag("custom");
  const form = new ui.ActionFormData();
  form.title("Start");
  form.body(`§eHero or Villain?`);
  form.button("Hero");
  form.button("Villain");
  form.show(player).then((r) => {
    if (r.canceled) {
      custom(player);
    }
    if (r.selection === 0) {
      player.runCommandAsync("event entity @s wesl3y:hero_name");
      player.addTag("hero");
      player.removeTag("custom");
      custom_hero(player);
    }
    if (r.selection === 1) {
      player.runCommandAsync("event entity @s wesl3y:villain_name");
      player.addTag("villain");
      player.removeTag("custom");
      custom_villain(player);
    }
  }
);}

function custom_hero(player) {
  const form = new ui.ActionFormData();
  form.title("Inf");
  form.body("[Heroi]\n- §eDerrote vilões para subir de level.\n§r- §eSeu nome de heroi é escolhido aleatório, ele não muda em nada, é apenas para deixar mais legal.\n§r- §eVilões comuns são fáceis de derrotar,mas cuidado com o Dabi (Ele é forte).\n§r- §eClick agachado em um policial para abrir o menu de loja.\n\n§r[Hero]\n- §eDefeat villains to level up.\n§r- §eYour hero name is chosen at random, it doesn't change at all, it's just to make it more cool.\n§r-§e Common villains are easy to defeat, but watch out for Dabi (He's strong).\n§r- §eCrouch click on a policeman to open the shop menu..");
  form.button("Ok");
  form.show(player).then((r) => {
    if (r.selection === 0) {
    }
  }
);}

function custom_villain(player) {
  const form = new ui.ActionFormData();
  form.title("Inf");
  form.body("[Vilão]\n- §cDerrote heróis para subir de level.\n§r- §cSeu nome de vilão e escolhido aleatório, ele não muda em nada, é apenas para deixar mais legal.\n§r- §cSeu maior problema com será o Deku, ele é super forte.\n§r- §cClick agachado em um bandido para abrir o menu de loja.\n\n§r[Villain]\n- §cDefeat heroes to level up.\n§r- §cHis villain name is chosen at random, he doesn't change anything, it's just to make it cooler.\n§r- §cYour biggest problem with Deku will be, he's super strong.\n§r- §cCrouch click on a bandit to open the shop menu.");
  form.button("Ok");
  form.show(player).then((r) => {
    if (r.selection === 0) {
    }
  }
);}

mc.world.events.entityHit.subscribe(hitEnt => {
  let hit = hitEnt.hitEntity;
  let entity = hitEnt.entity;
  if (entity.typeId != "minecraft:player" || entity == undefined || hit == undefined) return;
  if(hit.typeId == "wesl3y:npc" && hit.hasTag("variant1")) mei(hitEnt.entity);
  if(hit.typeId == "wesl3y:npc" && hit.hasTag("variant2")) aizawa(hitEnt.entity);
  if(hit.typeId == "wesl3y:npc" && hit.hasTag("variant3")) dabi(hitEnt.entity);
});


function mei(player) {
  const form = new ui.ActionFormData();
  form.title("Mei");
  form.button("All Might Suit\n§e[30 Money]");
  form.button("Bakugou Suit\n§e[15 Money]");
  form.button("Chargezuma Suit\n§e[15 Money]");
  form.button("Deku Suit\n§e[15 Money]");
  form.button("Deku Dark\n§e[20 Money]");
  form.button("Endeavor Suit\n§e[25 Money]");
  form.button("Eraser Suit\n§e[20 Money]");
  form.button("Hawks Suit\n§e[20 Money]");
  form.button("Lemillion Suit\n§e[20 Money]");
  form.button("Mirko Suit\n§e[20 Money]");
  form.button("Red Riot Suit\n§e[15 Money]");
  form.button("Rule Suit\n§e[15 Money]");
  form.button("Shoto Suit\n§e[20 Money]");
  form.button("Tsukuyomi Suit\n§e[15 Money]");
  form.button("Uravity Suit\n§e[15 Money]");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!30..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=30..}] wesl3y:all_might_suit 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=30..}] wesl3y:money 0 30");
    }
    if (r.selection === 1) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!15..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=15..}] wesl3y:bakugou_suit 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=15..}] wesl3y:money 0 15");
    }
    if (r.selection === 2) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!15..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=15..}] wesl3y:chargezuma_suit 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=15..}] wesl3y:money 0 15");
    }
    if (r.selection === 3) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!15..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=15..}] wesl3y:deku_suit 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=15..}] wesl3y:money 0 15");
    }
    if (r.selection === 4) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!20..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=20..}] wesl3y:deku_dark_suit 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=20..}] wesl3y:money 0 20");
    }
    if (r.selection === 5) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!25..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=25..}] wesl3y:endeavor_suit 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=25..}] wesl3y:money 0 25");
    }
    if (r.selection === 6) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!20..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=20..}] wesl3y:eraser_suit 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=20..}] wesl3y:money 0 20");
    }
    if (r.selection === 7) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!20..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=20..}] wesl3y:hawks_suit 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=20..}] wesl3y:money 0 20");
    }
    if (r.selection === 8) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!20..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=20..}] wesl3y:lemillion_suit 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=20..}] wesl3y:money 0 20");
    }
    if (r.selection === 9) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!20..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=20..}] wesl3y:mirko_suit 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=20..}] wesl3y:money 0 20");
    }
    if (r.selection === 10) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!15..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=15..}] wesl3y:red_riot_suit 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=15..}] wesl3y:money 0 15");
    }
    if (r.selection === 11) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!15..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=15..}] wesl3y:rule_suit 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=15..}] wesl3y:money 0 15");
    }
    if (r.selection === 12) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!20..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=20..}] wesl3y:shoto_suit 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=20..}] wesl3y:money 0 20");
    }
    if (r.selection === 13) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!15..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=15..}] wesl3y:tsukuyomi_suit 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=15..}] wesl3y:money 0 15");
    }
    if (r.selection === 14) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!15..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=15..}] wesl3y:uravity_suit 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=15..}] wesl3y:money 0 15");
    }
  }
);}

function aizawa(player) {
  const form = new ui.ActionFormData();
  form.title("Aizawa");
  form.button("8 Bandidos");
  form.button("Dabi");
  form.button("Shigaraki");
  form.button("Bônus");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      player.runCommandAsync(`scoreboard players set @s missions 0`);
      player.runCommandAsync(`tag @s add start_mission`);
    }
    if (r.selection === 1) {
      player.runCommandAsync(`scoreboard players set @s missions 1`);
      player.runCommandAsync(`tag @s add start_mission`);
    }
    if (r.selection === 2) {
      player.runCommandAsync(`scoreboard players set @s missions 2`);
      player.runCommandAsync(`tag @s add start_mission`);
    }
    if (r.selection === 3) {
      player.runCommandAsync(`scoreboard players set @s missions 3`);
      player.runCommandAsync(`tag @s add start_mission`);
    }
  }
);}
    
function dabi(player) {
  const form = new ui.ActionFormData();
  form.title("Dabi");
  form.button("Missions");
  form.button("All For One Suit\n§e[30 Money]");
  form.button("Katana Stain\n§e[10 Money]");
  form.button("Shigaraki Suit\n§e[25 Money]");
  form.button("Stain Suit\n§e[20 Money]");
  form.button("Quirk Random\n§e[64 Money]");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (player.hasTag("villain")) {
        villain2(player);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cNo Hero!!!"}]}`);
    }
    if (r.selection === 1) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!30..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=30..}] wesl3y:all_for_one_suit 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=30..}] wesl3y:money 0 30");
    }
    if (r.selection === 2) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!10..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=10..}] wesl3y:katana_stain 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=10..}] wesl3y:money 0 10");
    }
    if (r.selection === 3) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!25..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=25..}] wesl3y:shigaraki_suit 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=25..}] wesl3y:money 0 25");
    }
    if (r.selection === 4) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!20..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=20..}] wesl3y:stain_suit 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=20..}] wesl3y:money 0 20");
    }
    if (r.selection === 5) {
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:money,quantity=!64..}] {"rawtext":[{"translate":"shop.no_money"}]}`);
      player.runCommandAsync("give @s[hasitem={item=wesl3y:money,quantity=64..}] wesl3y:quirk_random 1");
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:money,quantity=64..}] wesl3y:money 0 64");
    }
  }
);}

function villain2(player) {
  const form = new ui.ActionFormData();
  form.title("Missions");
  form.button("8 Policemam");
  form.button("Shoto");
  form.button("Deku Dark");
  form.button("Bônus");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      player.runCommandAsync(`scoreboard players set @s missions 4`);
      player.runCommandAsync(`tag @s add start_mission`);
    }
    if (r.selection === 1) {
      player.runCommandAsync(`scoreboard players set @s missions 5`);
      player.runCommandAsync(`tag @s add start_mission`);
    }
    if (r.selection === 2) {
      player.runCommandAsync(`scoreboard players set @s missions 6`);
      player.runCommandAsync(`tag @s add start_mission`);
    }
    if (r.selection === 3) {
      player.runCommandAsync(`scoreboard players set @s missions 7`);
      player.runCommandAsync(`tag @s add start_mission`);
    }
  }
);}