import * as mc from "@minecraft/server";
import * as list from "./modules/quest_list.js";
import * as general from "./modules/general.js";
mc.system.runInterval(() => {
  for (const player of mc.world.getPlayers({ tags: ["start_mission"] })) {
    const quest = list.QUEST.list[general.getScore("missions", player)];
    player.removeTag("start_mission");
    if (!player.hasTag("in_mission")) {
      player.addTag("in_mission");
      player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.start_mission"}]}`);
      player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"${quest.start}"},{"text":"\n"},{"translate":"${quest.start2}"}]}`);
      inMission(player, quest);
    } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.in_mission"}]}`);
  }
}, 0.2);
mc.world.events.playerJoin.subscribe(data => {
  for (const player of mc.world.getPlayers()) {
    if (player.hasTag("in_mission")) inMission(player, list.QUEST.list[general.getScore("missions", player)]);
  }
});
function inMission(player, quest) {
  let objective = [...quest.inimigos];
  mc.system.runInterval(() => {
    if (player.hasTag("finish_mission")) finishMission(player, quest);
  }, 0.2);
  mc.world.events.entityHurt.subscribe(data => {
    try {
      if (data.damageSource.damagingEntity === player) {
        for (let index = 0; index < objective.length; index++) {
          if (objective[index] === data.hurtEntity.typeId) {
            if (data.hurtEntity.getComponent("minecraft:health").current <= 0) {
              objective.splice(index, 1);
              if (player.hasTag("in_mission") && !objective.length) return finishMission(player, quest); break;
            }
          }
        }
      }
    }
    catch (error) { }
  });
}
function finishMission(player, quest) {
  player.removeTag("finish_mission");
  player.removeTag("in_mission");
  player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§a"},{"translate":"text.finish_mission"},{"text":"\n+${quest.money} Money"}]}`);
  player.runCommandAsync(`give @s wesl3y:money ${quest.money} 0`);
  player.runCommandAsync(`scoreboard players reset @s missions`);
}